diff -ur old/REDHAT/SOURCES/yast2-nfs-client-2.13.4/src/Nfs.ycp REDHAT/SOURCES/yast2-nfs-client-2.13.4/src/Nfs.ycp
--- old/REDHAT/SOURCES/yast2-nfs-client-2.13.4/src/Nfs.ycp	2006-09-11 11:36:49.000000000 -0400
+++ REDHAT/SOURCES/yast2-nfs-client-2.13.4/src/Nfs.ycp	2007-12-28 18:53:26.000000000 -0500
@@ -13,6 +13,9 @@
  *   Dan Vesely <dan@suse.cz>
  *   Martin Vidner <mvidner@suse.cz>
  *
+ * Modified:
+ *   Zhao Shujing <pearly.zhao@oracle.com>
+ *
  * $Id: Nfs.ycp 32808 2006-09-11 15:38:26Z mvidner $
  */
 
@@ -283,7 +286,7 @@
 	if (size (nfs_entries) != 0)
 	{
 	    Service::Enable("portmap");
-	    Service::Enable("nfs");
+	    Service::Enable("netfs"); //use service netfs to mount nfs at RHEL.
 	    // #36737: it just runs sm_notify at boot time
 	    // replaces rpc.statd
 	    Service::Enable("nfsboot");
@@ -324,20 +327,20 @@
 
 	    Progress::NextStage ();
 
-	    Service::Stop("nfs");
+	    Service::Stop("netfs");
 
 	    Progress::NextStage ();
 	    if (size (nfs_entries) > 0)
 	    {
-		if (Service::Status ("portmap") != 0)
+		/*if (Service::Status ("portmap") != 0)
 		{
-		    // portmap must not be started if it is running already (see bug # 9999)
+		    / / portmap must not be started if it is running already (see bug # 9999)
 		    Service::Start("portmap");
-		}
+		}*/ //it will be started at netfs script at RHEL.
 
-		Service::Start("nfs");
+		Service::Start("netfs");
 		// #74597: if all mounts are noauto, $? is 6 (unconfigured)
-		integer status = Service::Status("nfs");
+		integer status = Service::Status("netfs");
 		if (status != 0 && status != 6)
 		{
 		    // error popup message
diff -ur old/REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite2.out REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite2.out
--- old/REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite2.out	2006-06-27 11:23:16.000000000 -0400
+++ REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite2.out	2007-12-29 14:26:51.000000000 -0500
@@ -21,25 +21,24 @@
 Read	.init.scripts.exists "portmap" true
 Read	.init.scripts.runlevel "portmap" $["nfs":$["start":["3", "5"], "stop":["3", "5"]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
 Read	.init.scripts.comment "portmap" $["nfs":$[], "portmap":$[]]
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.runlevel "nfs" $["nfs":$["start":["3", "5"], "stop":["3", "5"]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
-Read	.init.scripts.comment "nfs" $["nfs":$[], "portmap":$[]]
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.runlevel "netfs" $["nfs":$["start":["3", "5"], "stop":["3", "5"]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
+Read	.init.scripts.comment "netfs" $["nfs":$[], "portmap":$[]]
+Execute	.target.bash_output "/sbin/chkconfig --add netfs" $["exit":0, "stderr":"", "stdout":""]
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.runlevel "nfsboot" $["nfs":$["start":["3", "5"], "stop":["3", "5"]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
 Read	.init.scripts.comment "nfsboot" $["nfs":$[], "portmap":$[]]
-Execute	.target.bash_output "/sbin/insserv -d /etc/init.d/nfsboot" $["exit":0, "stderr":"", "stdout":""]
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs stop" $["TERM":"raw"] 0
-Read	.init.scripts.exists "portmap" true
-Execute	.target.bash "/etc/init.d/portmap status" $["TERM":"raw"] 0
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs start" $["TERM":"raw"] 0
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs status" $["TERM":"raw"] 0
+Execute	.target.bash_output "/sbin/chkconfig --add nfsboot" $["exit":0, "stderr":"", "stdout":""]
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs stop" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs start" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs status" $["TERM":"raw"] 0
 Read	.init.scripts.exists "SuSEfirewall2_init" true
 Execute	.target.bash "/etc/init.d/SuSEfirewall2_init status" $["TERM":"raw"] 0
 Return	true
@@ -62,27 +61,25 @@
 Read	.init.scripts.exists "portmap" true
 Read	.init.scripts.runlevel "portmap" $["nfs":$["start":[], "stop":[]], "portmap":$["start":[], "stop":[]]]
 Read	.init.scripts.comment "portmap" $["nfs":$[], "portmap":$[]]
-Execute	.target.bash_output "/sbin/insserv -d /etc/init.d/portmap" $["exit":0, "stderr":"", "stdout":""]
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.runlevel "nfs" $["nfs":$["start":[], "stop":[]], "portmap":$["start":[], "stop":[]]]
-Read	.init.scripts.comment "nfs" $["nfs":$[], "portmap":$[]]
-Execute	.target.bash_output "/sbin/insserv -d /etc/init.d/nfs" $["exit":0, "stderr":"", "stdout":""]
+Execute	.target.bash_output "/sbin/chkconfig --add portmap" $["exit":0, "stderr":"", "stdout":""]
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.runlevel "netfs" $["nfs":$["start":[], "stop":[]], "portmap":$["start":[], "stop":[]]]
+Read	.init.scripts.comment "netfs" $["nfs":$[], "portmap":$[]]
+Execute	.target.bash_output "/sbin/chkconfig --add netfs" $["exit":0, "stderr":"", "stdout":""]
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.runlevel "nfsboot" $["nfs":$["start":[], "stop":[]], "portmap":$["start":[], "stop":[]]]
 Read	.init.scripts.comment "nfsboot" $["nfs":$[], "portmap":$[]]
-Execute	.target.bash_output "/sbin/insserv -d /etc/init.d/nfsboot" $["exit":0, "stderr":"", "stdout":""]
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs stop" $["TERM":"raw"] 0
-Read	.init.scripts.exists "portmap" true
-Execute	.target.bash "/etc/init.d/portmap status" $["TERM":"raw"] 0
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs start" $["TERM":"raw"] 0
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs status" $["TERM":"raw"] 0
+Execute	.target.bash_output "/sbin/chkconfig --add nfsboot" $["exit":0, "stderr":"", "stdout":""]
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs stop" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs start" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs status" $["TERM":"raw"] 0
 Read	.init.scripts.exists "SuSEfirewall2_init" true
 Execute	.target.bash "/etc/init.d/SuSEfirewall2_init status" $["TERM":"raw"] 0
 Return	true
@@ -97,8 +94,8 @@
 Read	.etc.fstab [$["file":"/", "freq":1, "mntops":"defaults", "passno":2, "spec":"/dev/hda6", "vfstype":"ext3"]]
 Execute	.target.bash "/bin/cp $ORIG $BACKUP" $["BACKUP":"/etc/fstab.YaST2.save", "ORIG":"/etc/fstab"] 0
 Write	.etc.fstab [$["file":"/", "freq":1, "mntops":"defaults", "passno":2, "spec":"/dev/hda6", "vfstype":"ext3"]] true
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs stop" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs stop" $["TERM":"raw"] 0
 Read	.init.scripts.exists "SuSEfirewall2_init" true
 Execute	.target.bash "/etc/init.d/SuSEfirewall2_init status" $["TERM":"raw"] 0
 Return	true
@@ -113,8 +110,8 @@
 Read	.etc.fstab [$["file":"/", "freq":1, "mntops":"defaults", "passno":2, "spec":"/dev/hda6", "vfstype":"ext3"]]
 Execute	.target.bash "/bin/cp $ORIG $BACKUP" $["BACKUP":"/etc/fstab.YaST2.save", "ORIG":"/etc/fstab"] 0
 Write	.etc.fstab [$["file":"/", "freq":1, "mntops":"defaults", "passno":2, "spec":"/dev/hda6", "vfstype":"ext3"]] true
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs stop" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs stop" $["TERM":"raw"] 0
 Read	.init.scripts.exists "SuSEfirewall2_init" true
 Execute	.target.bash "/etc/init.d/SuSEfirewall2_init status" $["TERM":"raw"] 0
 Return	true
diff -ur old/REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite.out REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite.out
--- old/REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite.out	2006-06-27 11:23:15.000000000 -0400
+++ REDHAT/SOURCES/yast2-nfs-client-2.13.4/testsuite/tests/readwrite.out	2007-12-29 14:24:28.000000000 -0500
@@ -17,25 +17,24 @@
 Read	.init.scripts.exists "portmap" true
 Read	.init.scripts.runlevel "portmap" $["network":$["start":[], "stop":[]], "networkmanager":$["start":["3", "5"], "stop":["3", "5"]], "nfs":$["start":["3", "5"], "stop":["3", "5"]], "nfsboot":$["start":[], "stop":[]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
 Read	.init.scripts.comment "portmap" $["nfs":$[], "portmap":$[]]
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.exists "nfs" true
-Read	.init.scripts.runlevel "nfs" $["network":$["start":[], "stop":[]], "networkmanager":$["start":["3", "5"], "stop":["3", "5"]], "nfs":$["start":["3", "5"], "stop":["3", "5"]], "nfsboot":$["start":[], "stop":[]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
-Read	.init.scripts.comment "nfs" $["nfs":$[], "portmap":$[]]
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.exists "netfs" true
+Read	.init.scripts.runlevel "netfs" $["network":$["start":[], "stop":[]], "networkmanager":$["start":["3", "5"], "stop":["3", "5"]], "nfs":$["start":["3", "5"], "stop":["3", "5"]], "nfsboot":$["start":[], "stop":[]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
+Read	.init.scripts.comment "netfs" $["nfs":$[], "portmap":$[]]
+Execute	.target.bash_output "/sbin/chkconfig --add netfs" $["exit":0, "stderr":"", "stdout":""]
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.exists "nfsboot" true
 Read	.init.scripts.runlevel "nfsboot" $["network":$["start":[], "stop":[]], "networkmanager":$["start":["3", "5"], "stop":["3", "5"]], "nfs":$["start":["3", "5"], "stop":["3", "5"]], "nfsboot":$["start":[], "stop":[]], "portmap":$["start":["3", "5"], "stop":["3", "5"]]]
 Read	.init.scripts.comment "nfsboot" $["nfs":$[], "portmap":$[]]
-Execute	.target.bash_output "/sbin/insserv -d /etc/init.d/nfsboot" $["exit":0, "stderr":"", "stdout":""]
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs stop" $["TERM":"raw"] 0
-Read	.init.scripts.exists "portmap" true
-Execute	.target.bash "/etc/init.d/portmap status" $["TERM":"raw"] 0
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs start" $["TERM":"raw"] 0
-Read	.init.scripts.exists "nfs" true
-Execute	.target.bash "/etc/init.d/nfs status" $["TERM":"raw"] 0
+Execute	.target.bash_output "/sbin/chkconfig --add nfsboot" $["exit":0, "stderr":"", "stdout":""]
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs stop" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs start" $["TERM":"raw"] 0
+Read	.init.scripts.exists "netfs" true
+Execute	.target.bash "/etc/init.d/netfs status" $["TERM":"raw"] 0
 Read	.init.scripts.exists "SuSEfirewall2_init" true
 Execute	.target.bash "/etc/init.d/SuSEfirewall2_init status" $["TERM":"raw"] 0
 Return	true